/*******************************************************************************
 * 
 * jKiwi -- A virtual makeover and hairstyler application
 * Copyright (c) 2007-2008 Dan Mihai Ile, Maria Joao Roque Barbado Leal
 * 
 * This file is part of jKiwi.
 * 
 * jKiwi is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * jKiwi is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************/

package blending;


/**
 * Multiply mode multiplies the pixel values of the upper layer
 * with those of the layer below it and then divides the result
 * by 255. The result is usually a darker image.
 * <p>
 * The equation is: R = T × B ÷ 255
 * </p>
 */
public class MultiplyBlendingContext extends BlendingContext {

	@Override
	public int[] applyBlending(int[] srcPixel, int[] dstPixel) {
		return new int[] {
				(srcPixel[0] * dstPixel[0]) >> 8,
				(srcPixel[1] * dstPixel[1]) >> 8,
				(srcPixel[2] * dstPixel[2]) >> 8,
				dstPixel[3] //use only dst's alpha value
		};
	}
}